import QtQuick 1.1
import qb.components 1.0
import qb.base 1.0;

App {
	id: root
	// These are the URL's for the QML resources from which our widgets will be instantiated.
	// By making them a URL type property they will automatically be converted to full paths,
	// preventing problems when passing them around to code that comes from a different path.
	property url trayUrl : "DomoticzTray.qml";
	property url thumbnailIcon: "./drawables/DomoticzSystrayIcon.png"
	property url domoticzScreenUrl : "DomoticzScreen.qml"

	property string timeStr
	property string dateStr
	//Edit these settings:
	property string hostName: "192.168.123.11"	// IP Adress of Domoticz
	property string portNum: "8080"				// Port number of Domoticz
	property string baseUrl: "/domoticz"		// Problably only needed if Domoticz runs behind a reverse proxy. Otherwise keep this field empty ("")
	//Stop editing here!

	property string switch1idx: "72" //put IDX of switch/wall plug here
	property string switch1StatusIcon
	property string switch1Name
	
	property string switch2idx: "80" //put IDX of switch/wall plug here
	property string switch2StatusIcon
	property string switch2Name

	property string switch3idx: "95" //put IDX of switch/wall plug here
	property string switch3StatusIcon
	property string switch3Name

	property string switch4idx: "106" //put IDX of switch/wall plug here
	property string switch4StatusIcon
	property string switch4Name
	
	property string switch5idx: "117" //put IDX of switch/wall plug here
	property string switch5StatusIcon
	property string switch5Name
	
	property string switch6idx: "149" //put IDX of switch/wall plug here
	property string switch6StatusIcon
	property string switch6Name
	
//scenes 1-2-3 are automatically queried
//make sure that you use Domoticz scenes 1-2-3 for Toon
	property string scene1idx
	property string scene1StatusName
	property string scene1StatusIcon
	property string scene1Name

	property string scene2idx
	property string scene2StatusName
	property string scene2StatusIcon
	property string scene2Name

//	property string scene3idx
//	property string scene3StatusName
//	property string scene3StatusIcon
//	property string scene3Name

	function init() {
		registry.registerWidget("systrayIcon", trayUrl, this, "domoticzTray");
		registry.registerWidget("screen", domoticzScreenUrl, this);
	}

	function readDeviceStatus1(idx) {
		var xmlhttp = new XMLHttpRequest();
		var i;
		var j;
		var tmpDeviceStatus1;
		xmlhttp.onreadystatechange=function() {
			if (xmlhttp.readyState == 4) {
				if (xmlhttp.status == 200) {
					var res = xmlhttp.responseText;
										
					i = res.indexOf('"Name"');
					j = res.indexOf('"', i+10);
						   if (idx == switch1idx) {
						switch1Name = res.substring(i+10 , j);
					} else if (idx == switch2idx) {
						switch2Name = res.substring(i+10 , j);
					} else if (idx == switch3idx) {
						switch3Name = res.substring(i+10 , j);
					} else if (idx == switch4idx) {
						switch4Name = res.substring(i+10 , j);
					} else if (idx == switch5idx) {
						switch5Name = res.substring(i+10 , j);
					} else 	  {
						switch6Name = res.substring(i+10 , j);
					}
					
					i = res.indexOf('"Status"', j);
					j = res.indexOf('"', i+12);
					tmpDeviceStatus1 = res.substring(i+12, j);
					if (idx == switch1idx) {
						if (tmpDeviceStatus1 == "On") {
							switch1StatusIcon = "./drawables/Light48_On.png";
						} else {
							switch1StatusIcon = "./drawables/Light48_Off.png";
							}
					} else if (idx == switch2idx) {
						if (tmpDeviceStatus1 == "On") {
							switch2StatusIcon = "./drawables/Light48_On.png";
						} else {
							switch2StatusIcon = "./drawables/Light48_Off.png";
							}
					} else if (idx == switch3idx) {
						if (tmpDeviceStatus1 == "On") {
							switch3StatusIcon = "./drawables/Light48_On.png";
						} else {
							switch3StatusIcon = "./drawables/Light48_Off.png";
							}
					} else if (idx == switch4idx) {
						if (tmpDeviceStatus1 == "On") {
							switch4StatusIcon = "./drawables/Light48_On.png";
						} else {
							switch4StatusIcon = "./drawables/Light48_Off.png";
							}
					} else if (idx == switch5idx) {
						if (tmpDeviceStatus1 == "On") {
							switch5StatusIcon = "./drawables/Light48_On.png";
						} else {
							switch5StatusIcon = "./drawables/Light48_Off.png";
							}		
					} else {
						if (tmpDeviceStatus1 == "On") {
							switch6StatusIcon = "./drawables/FanOn.png";
						} else {
							switch6StatusIcon = "./drawables/FanOff.png";
							}
					}
				}
			}
		}
		xmlhttp.open("GET", "http://"+hostName+":"+portNum+""+baseUrl+"/json.htm?type=devices&rid="+idx, true);
		xmlhttp.send();
	}
	
function readSceneStatus() {
	var xmlhttp = new XMLHttpRequest();
	var i;
	var j;
	//var tmpSceneStatus1;
	xmlhttp.onreadystatechange=function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200) {
				var res = xmlhttp.responseText;
			   
			   //scene1 json
				i = res.indexOf('"idx"', j);
				j = res.indexOf('"', i+9);
				scene1idx =  res.substring(i+9, j);
				
				i = res.indexOf('"Name"');
				j = res.indexOf('"', i+10);
				scene1Name = res.substring(i+10 , j);
			   
				i = res.indexOf('"Status"', j);
				j = res.indexOf('"', i+12);
				scene1StatusName = res.substring(i+12, j);
				if (scene1idx == "1") {
						if (scene1StatusName == "On") {
							scene1StatusIcon = "./drawables/GroupOff.png";
						} else if (scene1StatusName == "Off") {
							scene1StatusIcon = "./drawables/GroupOn.png";
						} else {
							scene1StatusIcon = "./drawables/GroupOff.png";
						}
					}
				//scene2 json
				res = res.slice(i)
				i = res.indexOf('"idx"', j);
				j = res.indexOf('"', i+9);
				scene2idx =  res.substring(i+9, j);
				
				i = res.indexOf('"Name"');
				j = res.indexOf('"', i+10);
				scene2Name = res.substring(i+10 , j);
			   
				i = res.indexOf('"Status"', j);
				j = res.indexOf('"', i+12);
				scene2StatusName = res.substring(i+12, j);	
				if (scene2idx == "2") {
						if (scene2StatusName == "On") {
							scene2StatusIcon = "./drawables/GroupOff.png";
						}  else if (scene2StatusName == "Off") {
							scene2StatusIcon = "./drawables/GroupOn.png";
						} else {
							scene2StatusIcon = "./drawables/GroupOff.png";
							}
					}
				//scene3 json
//				res = res.slice(i)
//				i = res.indexOf('"idx"', j);
//				j = res.indexOf('"', i+9);
//				scene3idx =  res.substring(i+9, j);
				
//				i = res.indexOf('"Name"');
//				j = res.indexOf('"', i+10);
//				scene3Name = res.substring(i+10 , j);
			   
//				i = res.indexOf('"Status"', j);
//				j = res.indexOf('"', i+12);
//				scene3StatusName = res.substring(i+12, j);	
//				if (scene3idx == "3") {
//						if (scene3StatusName == "On") {
//							scene3StatusIcon = "./drawables/GroupOff.png";
//						}  else if (scene3StatusName == "Off") {
//							scene3StatusIcon = "./drawables/GroupOn.png";
//						} else {
//							scene3StatusIcon = "./drawables/GroupOff.png";
//							}
//					}
				//ending tags
			}
		}
	}
	xmlhttp.open("GET", "http://"+hostName+":"+portNum+""+baseUrl+"/json.htm?type=scenes", true);
	xmlhttp.send();
}
	
	function updateDomoticzLight1() {
		readDeviceStatus1(switch1idx);
	}
	function updateDomoticzLight2() {
		readDeviceStatus1(switch2idx);
	}
	function updateDomoticzLight3() {
		readDeviceStatus1(switch3idx);
	}
	function updateDomoticzLight4() {
		readDeviceStatus1(switch4idx);
	}
	function updateDomoticzLight5() {
		readDeviceStatus1(switch5idx);
	}
	function updateDomoticzLight6() {
		readDeviceStatus1(switch6idx);
	}
	function updateSceneStatus() {
		readSceneStatus();
	}

	Timer {
		id: datetimeTimer
		interval: 10000
		triggeredOnStart: true
		running: true
		repeat: true
		onTriggered: {
			updateDomoticzLight1();
			updateDomoticzLight2();
			updateDomoticzLight3();
			updateDomoticzLight4();
			updateDomoticzLight5();
			updateDomoticzLight6();
			updateSceneStatus();
		}
	}

}
